# coding: utf-8

"""
    AIMMS PRO REST API

    OpenAPI Specification of the AIMMS PRO REST API

    The version of the OpenAPI document: v2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from aimms_openapi_client.models.entity_authorization import EntityAuthorization
from aimms_openapi_client.models.pro_storage_bucket_response import (
    PROStorageBucketResponse,
)
from aimms_openapi_client.models.pro_storage_object_response import (
    PROStorageObjectResponse,
)
from typing import Optional, Set
from typing_extensions import Self


class PROStorageBucketInfo(BaseModel):
    """
    PROStorageBucketInfo
    """  # noqa: E501

    authorizations: Optional[List[EntityAuthorization]] = None
    child_buckets: Optional[List[PROStorageBucketResponse]] = Field(
        default=None, alias="childBuckets"
    )
    child_objects: Optional[List[PROStorageObjectResponse]] = Field(
        default=None, alias="childObjects"
    )
    create_date: Optional[StrictStr] = Field(default=None, alias="createDate")
    id: Optional[StrictStr] = None
    label: Optional[StrictStr] = None
    objects: Optional[StrictInt] = None
    path: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = [
        "authorizations",
        "childBuckets",
        "childObjects",
        "createDate",
        "id",
        "label",
        "objects",
        "path",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PROStorageBucketInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in authorizations (list)
        _items = []
        if self.authorizations:
            for _item_authorizations in self.authorizations:
                if _item_authorizations:
                    _items.append(_item_authorizations.to_dict())
            _dict["authorizations"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in child_buckets (list)
        _items = []
        if self.child_buckets:
            for _item_child_buckets in self.child_buckets:
                if _item_child_buckets:
                    _items.append(_item_child_buckets.to_dict())
            _dict["childBuckets"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in child_objects (list)
        _items = []
        if self.child_objects:
            for _item_child_objects in self.child_objects:
                if _item_child_objects:
                    _items.append(_item_child_objects.to_dict())
            _dict["childObjects"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PROStorageBucketInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "authorizations": (
                    [
                        EntityAuthorization.from_dict(_item)
                        for _item in obj["authorizations"]
                    ]
                    if obj.get("authorizations") is not None
                    else None
                ),
                "childBuckets": (
                    [
                        PROStorageBucketResponse.from_dict(_item)
                        for _item in obj["childBuckets"]
                    ]
                    if obj.get("childBuckets") is not None
                    else None
                ),
                "childObjects": (
                    [
                        PROStorageObjectResponse.from_dict(_item)
                        for _item in obj["childObjects"]
                    ]
                    if obj.get("childObjects") is not None
                    else None
                ),
                "createDate": obj.get("createDate"),
                "id": obj.get("id"),
                "label": obj.get("label"),
                "objects": obj.get("objects"),
                "path": obj.get("path"),
            }
        )
        return _obj
